void UpdateScreen()
{
	DWORD* dp=ptc_screen;
	DWORD* sp=screen;
	for(int y=0;y<240;y++)
	{
		for(int x=0;x<320;x++)
		{
			*dp++=*sp;
			*dp++=*sp++;
		}
		sp-=320;
		for(int x=0;x<320;x++)
		{
			*dp++=*sp;
			*dp++=*sp++;
		}
	}
	ptc_update(ptc_screen);
}

void DrawBar(int sx, int sy, int w, int h, DWORD color)
{
	for(int y=sy;y<sy+h;y++)
	{
		if(y<0) continue;
		if(y>=240) break;
		int i=y*320+sx;
		for(int x=sx;x<sx+w;x++)
			if(x>=0 && x<320)
				screen[i++]=color;
	}
}

void DrawSprite(Sprite& sprite, int sx, int sy, bool flipped)
{
	DWORD* dps=screen+sy*320;
	for(int y=0;y<sprite.height;y++)
	{
		if(sy+y<0)
		{
			y=-sy-1;
			dps=screen;
			continue;
		}
		if(sy+y>=240)
			break;
		DWORD* dp=dps+sx;
		int fx=0;
		int w=sprite.width;
		if(sx<0)
		{
			dp-=sx;
			fx-=sx;
//			sp-=sx;
			w+=sx;
		}
		if(sx+sprite.width>320)
			w-=sx+sprite.width-320;
		int ds=1;
		DWORD* sp;
		if(flipped)
		{
//			sp+=sprite.width;
			sp=sprite.data+y*sprite.width+sprite.width-fx-1;
			ds=-1;
		}
		else
			sp=sprite.data+y*sprite.width+fx;
		for(int x=0;x<w;x++)
		{
			DWORD c=*sp;
			sp+=ds;
			if(c&0xFF000000)
				*dp=c;
			dp++;
		}
		dps+=320;
	}
}

void DrawSprite(Sprite& sprite, int sx, int sy)
{
	DrawSprite(sprite, sx, sy, false);
}

bool LoadSprite(Sprite& sprite, char* filename)
{
	FILE *fp=fopen(filename, "rb");
	if(fp==NULL)
		return false;
	png_structp png_ptr=png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if(!png_ptr)
		return false;
	png_infop info_ptr=png_create_info_struct(png_ptr);
	if(!info_ptr)
	{
		png_destroy_read_struct(&png_ptr, (png_infopp)NULL, (png_infopp)NULL);
		return false;
	}
	png_init_io(png_ptr, fp);
	png_read_info(png_ptr, info_ptr);
	png_read_update_info(png_ptr, info_ptr);
	int width=info_ptr->width;
	int height=info_ptr->height;
	int channels=info_ptr->channels;
	sprite.width=width;
	sprite.height=height;
	BYTE *rgb_image=(BYTE*)malloc(width*height*channels);
	sprite.data=(DWORD*)malloc(width*height*sizeof(DWORD));
	png_byte **row_pointers=(png_byte**)malloc(height*sizeof(png_byte*));
	for(int i=0;i<height;i++)
		row_pointers[i]=(png_byte*)(rgb_image+i*width*channels);
	png_set_rows(png_ptr, info_ptr, (png_bytepp)(&row_pointers));
	png_read_image(png_ptr, row_pointers);
	png_read_end(png_ptr, NULL);
	png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
	fclose(fp);
	free(row_pointers);
	for(int y=0;y<height;y++)
	{
		int si=y*width*channels;
		int di=y*width;
		for(int x=0;x<width;x++)
		{
			DWORD pixel=0xFF000000;
			pixel|=rgb_image[si+0]<<16;
			pixel|=rgb_image[si+1]<<8;
			pixel|=rgb_image[si+2];
			if(rgb_image[si+0]==255 &&
			   rgb_image[si+1]==240 &&
			   rgb_image[si+2]==200)
				pixel=0x00FFF0C8;
			sprite.data[di++]=pixel;
			si+=channels;
		}
	}
	free(rgb_image);
	GCAdd(sprite.data, GCMALLOC);
	return true;
}

